const
  ACC_PUBLIC = 1;
  ACC_PRIVATE = 2;
  ACC_PROTECTED = 4;
  ACC_STATIC = 8;
  ACC_FINAL = 16;
  ACC_SYNCHRONIZED = 32;
  ACC_SUPER = 32;
  ACC_VOLATILE = 64;
  ACC_TRANSIENT = 128;
  ACC_NATIVE = 256;
  ACC_INTERFACE = 512;
  ACC_ABSTRACT = 1024;
  {}
  CONSTANT_Utf8 = 1;
  CONSTANT_Unicode = 2;
  CONSTANT_Integer = 3;
  CONSTANT_Float = 4;
  CONSTANT_Long = 5;
  CONSTANT_Double = 6;
  CONSTANT_Class = 7;
  CONSTANT_String = 8;
  CONSTANT_Fieldref = 9;
  CONSTANT_Methodref = 10;
  CONSTANT_InterfaceMethodref = 11;
  CONSTANT_NameAndType = 12;
type
  tarr=array[0..$FFFF-1] of byte;
var
  cf : record {ClassFile}
    magic              : longInt;
    minor_version      : word;
    major_version      : word;
    constant_pool_count: word;
    cp_info            :^tarr;    {[constant_pool_count-1]}
    access_flags       : word;
    this_class         : word;
    super_class        : word;
    interfaces_count   : word;
    interfaces         :^tarr;    {[interfaces_count]}
    fields_count       : word;
    field_info         :^tarr;    {fields[fields_count]}
    methods_count      : word;
    method_info        :^tarr;    {methods[methods_count]}
    attributes_count   : word;
    attribute_info     :^tarr;    {attributes[attribute_count]}
    pc,pi,pf,pm,pa     : integer; {㪠⥫   }
  end;
  vartable   :^tarr;
  pw1,pw2    :^word;
  ps         :^string;
  pl         :^longInt;
  i          : integer;
  ch         : char;
  s,s2       : string;
  f          : file;


procedure error(msg : string);
begin  {뢥 訡  }
  write('ERROR: '+msg);
  readln;
  halt;
end;

procedure getc;
var    {  ᨬ  䠩}
  n : integer;
begin
  blockRead(f,ch,1,n);
  if n=0 then error('End Of File.');
end;

procedure skipSpaces;
begin  {ய ஡  ᫨  ਨ  䨣.᪮}
  while (ch<=#32) or (ch='{') do
  begin
    if ch='{' then  repeat getc; until ch='}';
    getc;
  end;
end;

procedure skip(c:char);
begin  {ய ᨬ}
  skipSpaces;
  if ch<>c then error('char not found: "'+c+'"');
  getc;
end;

function gets : string;
var    { ப}
  s : string;
begin
  s:='';
  skipSpaces;
  while ch in ['_','/',';','(',')','A'..'Z','a'..'z'] do
  begin
    s:=s+ch;
    getc;
  end;
  gets := s;
end;

function getb : string;
var    { ப 祭   窨}
  s : string;
begin
  s:='';
  skip('"');
  while (ch<>'"') do
  begin
    s:=s+ch;
    getc;
    if (ch=#13) then error('not found ''"''');
  end;
  getc;
  getb := s;
end;

function constfind(typ:byte; name:string; w1,w2:word) : integer;
{ ⠭ typ    ᫨  ⮥  ᮤন}
{  CONSTANT_Fieldref  .}
var
  i,n,p : integer;
begin
  p:=0;
  for i := 1 to cf.constant_pool_count do
  begin
    ps:=@cf.cp_info^[p];
    inc(p,length(ps^)+1);
    if (typ=cf.cp_info^[p]) and (ps^=name) and (name<>'') then
    begin
      constfind := i;
      exit;
    end;
    case cf.cp_info^[p] of
      CONSTANT_Class:
        if typ=CONSTANT_Class then
        begin
          inc(p);
          pw1:=@cf.cp_info^[p];
          inc(p,2);
          if (pw1^=w1) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+2);
      CONSTANT_Fieldref:
        if typ=CONSTANT_Fieldref then
        begin
          inc(p);
          pw1:=@cf.cp_info^[p];
          inc(p,2);
          pw2:=@cf.cp_info^[p];
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_Methodref:
        if typ=CONSTANT_Methodref then
        begin
          inc(p);
          pw1:=@cf.cp_info^[p];
          inc(p,2);
          pw2:=@cf.cp_info^[p];
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_InterfaceMethodref:
        if typ=CONSTANT_InterfaceMethodref then
        begin
          inc(p);
          pw1:=@cf.cp_info^[p];
          inc(p,2);
          pw2:=@cf.cp_info^[p];
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_String:
        if typ=CONSTANT_String then
        begin
          inc(p);
          pw1:=@cf.cp_info^[p];
          inc(p,2);
          if (pw1^=w1) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+2);
      CONSTANT_Integer:
        if typ=CONSTANT_Integer then
        begin
          inc(p);
          pw1:=@cf.cp_info^[p];
          inc(p,2);
          pw2:=@cf.cp_info^[p];
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_Float:
        if typ=CONSTANT_Float then
        begin
          inc(p);
          pw1:=@cf.cp_info^[p];
          inc(p,2);
          pw2:=@cf.cp_info^[p];
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_Long:
        {if typ=CONSTANT_Long then (*㦭 ࠡ ⮡ ࠢ 8-⮢*)
        begin
          inc(p);
          pw1:=@constPool^[p];
          inc(p,2);
          pw2:=@constPool^[p];
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else{} inc(p,1+8 );
      CONSTANT_NameAndType:
        if typ=CONSTANT_NameAndType then
        begin
          inc(p);
          pw1:=@cf.cp_info^[p];
          inc(p,2);
          pw2:=@cf.cp_info^[p];
          inc(p,2);
          if (pw1^=w1) and (pw2^=w2) then
          begin
            constfind := i;
            exit;
          end;
        end
        else inc(p,1+4);
      CONSTANT_Utf8, CONSTANT_Unicode:
        begin      {null=$0000, 1b=$0001-$007F,2b=$0008-$07FF,3b=$0800-$FFFF{}
          inc(p);
          pw1:=@cf.cp_info^[p];
          if typ in [CONSTANT_Utf8, CONSTANT_Unicode] then
          begin
            s:='';
            inc(p,2);
            for n := 1 to pw1^ do
            begin
              s:=s+chr(cf.cp_info^[p]);
              inc(p);
            end;
            if (s=name) then  { ப  㠫쭮 ᮢ  ᮤন}
            begin
              constfind := i;
              exit;
            end;
          end
          else inc(p,pw1^+2);
        end;
    end;
  end;
  constfind := 0;
end;

function constadd(typ:byte; name,str:string) : integer;
{  ⠭  ,।⥫쭮 ஢ਢ ⢮ }
var
  i     : integer;
  w1,w2 : word;
begin
  i:=constfind(typ,name,0,0);
  if (i>0) then
  begin
    constadd := i;
    exit;
  end;
  case typ of
    CONSTANT_Utf8,CONSTANT_Unicode:
      begin
        w1:=constfind(CONSTANT_Utf8,str,0,0); { ப  ᮤন}
        if w1=0 then
        begin
          cf.cp_info^[cf.pc]:=length(name);  {..  ਢ뢠 ,}
          inc(cf.pc);                       {  ப }
          for i := 1 to length(name) do  { ࠭, 祬  ⠢}
          begin
            cf.cp_info^[cf.pc] := ord(name[i]);
            inc(cf.pc);
          end;
          cf.cp_info^[cf.pc]:=typ;
          inc(cf.pc);
          pw1:=@cf.cp_info^[cf.pc];
          pw1^:=length(name);
          inc(cf.pc,2);
          for i := 1 to length(str) do
          begin
            cf.cp_info^[cf.pc] := ord(str[i]);
            inc(cf.pc);
          end;
          inc(cf.constant_pool_count);
          constadd := cf.constant_pool_count;
        end
          else constadd := w1;
      end;
    CONSTANT_Integer:   ;    {}
    CONSTANT_Float:     ;    {}
    CONSTANT_Long:      ;    {}
    CONSTANT_Double:    ;    {}
    CONSTANT_Class:
    begin
      w1:=constadd(CONSTANT_Utf8,str,'');
      w2:=constfind(CONSTANT_Class,'',w1,0);
      if w2=0 then
      begin
        cf.cp_info^[cf.pc]:=length(name);
        inc(cf.pc);
        for i := 1 to length(name) do
        begin
          cf.cp_info^[cf.pc] := ord(name[i]);
          inc(cf.pc);
        end;
        cf.cp_info^[cf.pc]:=typ;
        inc(cf.pc);
        pw1:=@cf.cp_info^[cf.pc];
        pw1^:=w1;
        inc(cf.pc,2);
        inc(cf.constant_pool_count);
        constadd := cf.constant_pool_count;
      end
        else constadd := w2;
    end;
    CONSTANT_String:
    begin
      w1:=constadd(CONSTANT_Utf8,str,'');
      w2:=constfind(CONSTANT_String,'',w1,0);
      if (w2=0) then
      begin
        pw1:=@cf.cp_info^[cf.pc];
        pw1^:=w1;
        inc(cf.pc,2);
        inc(cf.constant_pool_count);
        constadd := cf.constant_pool_count;
      end
       else constadd := w2;
    end;
    CONSTANT_Fieldref,
    CONSTANT_Methodref,
    CONSTANT_InterfaceMethodref:
    begin
      {s:='';
      for i := 1 to length(name) do
        if not (name[i] in ['_']) then s:=s+name[i]
          else s:=s+'/';
      w1:=constadd(CONSTANT_Class,s,name);{}
      w1:=constfind(CONSTANT_Class,name,0,0);
      w2:=constfind(CONSTANT_NameAndType,str,0,0);
      if (w1=0) then error('class "'+name+'" not found') else
      if (w2=0) then error('NameAndType "'+str+'" not found') else
      begin
        i:=constfind(typ,'',w1,w2);
        if i=0 then
        begin
          cf.cp_info^[cf.pc]:=length(name);
          inc(cf.pc);
          for i := 1 to length(name) do
          begin
            cf.cp_info^[cf.pc] := ord(name[i]);
            inc(cf.pc);
          end;
          pw1:=@ cf.cp_info^[cf.pc];
          pw1^:=w1;
          inc(cf.pc,2);
          pw1:=@cf.cp_info^[cf.pc];
          pw1^:=w2;
          inc(cf.pc,2);
          inc(cf.constant_pool_count);
          constadd := cf.constant_pool_count;
        end
          else constadd := i;
      end;
    end;
    CONSTANT_NameAndType:
    begin
      w1:=constadd(CONSTANT_Utf8,name,'');
      w2:=constadd(CONSTANT_Utf8,str,'');
      i:=constfind(CONSTANT_NameAndType,'',w1,w2);
      if i=0 then
      begin
        cf.cp_info^[cf.pc]:=length(name);
        inc(cf.pc);
        for i := 1 to length(name) do
        begin
          cf.cp_info^[cf.pc] := ord(name[i]);
          inc(cf.pc);
        end;
        pw1:=@cf.cp_info^[cf.pc];
        pw1^:=w1;
        inc(cf.pc,2);
        pw1:=@cf.cp_info^[cf.pc];
        pw1^:=w2;
        inc(cf.pc,2);
        inc(cf.constant_pool_count);
        constadd := cf.constant_pool_count;
      end
        else constadd := i;
    end;
  end;
end;

function flags(s : string) : word;
{ 䫠  ப-ᯨ᪠}
var
  f : word;
begin
  f := 0;
  if pos('PUBLIC',s)>0       then f := f and 1;
  if pos('PRIVATE',s)>0      then f := f and 2;
  if pos('PROTECTED',s)>0    then f := f and 4;
  if pos('STATIC',s)>0       then f := f and 8;
  if pos('FINAL',s)>0        then f := f and 16;
  if pos('SYNCHRONIZED',s)>0 then f := f and 32;
  if pos('SUPER',s)>0        then f := f and 32;
  if pos('VOLATILE',s)>0     then f := f and 64;
  if pos('TRANSIENT',s)>0    then f := f and 128;
  if pos('NATIVE',s)>0       then f := f and 256;
  if pos('INTERFACE',s)>0    then f := f and 512;
  if pos('ABSTRACT',s)>0     then f := f and 1024;
  flags := f;
end;


procedure interfaces(s1 : string);
var
  s2 : string;
begin
  s2:='';
  for i := 1 to length(s1) do
    if not (s1[i] in ['/']) then s2:=s2+s1[i]
      else s2:=s2+'_';
  i:=constadd(CONSTANT_Class,s2,s1);
  pw1:=@cf.interfaces^[cf.pi];
  pw1^:=i;
  inc(cf.pi,2);
  inc(cf.interfaces_count);
end;


procedure fields(f : word;  s1,s2 : string);
begin
  pw1:=@cf.field_info^[cf.pf];           {acces flags}
  pw1^:=f;
  inc(cf.pf,2);
  i:=constadd(CONSTANT_Class,s1,'');
  pw1:=@cf.field_info^[cf.pf];           {name index}
  pw1^:=i;
  inc(cf.pf,2);
  i:=constadd(CONSTANT_Class,s2,'');
  pw1:=@cf.field_info^[cf.pf];           {signature index}
  pw1^:=i;
  inc(cf.pf,2);
  pw1:=@cf.field_info^[cf.pf];           {attributes count}
  pw1^:=0;
  inc(cf.pf,2);
  inc(cf.fields_count);
end;


procedure method(f : word;  s1,s2 : string);
begin
  pw1:=@cf.method_info^[cf.pm];           {acces flags}
  pw1^:=f;
  inc(cf.pf,2);
  i:=constadd(CONSTANT_Class,s1,'');
  pw1:=@cf.method_info^[cf.pf];           {name index}
  pw1^:=i;
  inc(cf.pf,2);
  i:=constadd(CONSTANT_Class,s2,'');
  pw1:=@cf.method_info^[cf.pf];           {signature index}
  pw1^:=i;
  inc(cf.pf,2);
(*  pw1:=@cf.method_info^[cf.pf];           {attributes count}
  pw1^:=0;
  inc(cf.pf,2);*)
  inc(cf.methods_count);
end;


begin
  assign(f,'j.txt');
  reset(f);
  getMem(cf.cp_info,            $FFFF);
  getMem(cf.interfaces,         $7FFF);
  getMem(cf.field_info,         $7FFF);
  getMem(cf.method_info,        $FFFF);
  getMem(cf.attribute_info,     $7FFF);
  fillChar(cf.cp_info^,         $FFFF, 0);
  fillChar(cf.interfaces^,      $7FFF, 0);
  fillChar(cf.field_info^,      $7FFF, 0);
  fillChar(cf.method_info^,     $FFFF, 0);
  fillChar(cf.attribute_info^,  $7FFF, 0);
  cf.constant_pool_count := 0;
  cf.interfaces_count := 0;
  cf.fields_count := 0;
  cf.methods_count := 0;
  cf.attributes_count := 0;
  cf.pc := 0;
  cf.pi := 0;
  cf.pf := 0;
  cf.pm := 0;
  cf.pa := 0;
  ch := #32;
  s:=gets;
  while not eof(f) do
  begin
    if (s='class') then
    begin
      constadd(CONSTANT_Class,gets,getb);
    end
    else if (s='nameandtype') then
    begin
      constadd(CONSTANT_NameAndType,gets,getb);
    end
    else if (s='string') then
    begin
      constadd(CONSTANT_Utf8,gets,getb);
    end
    else if (s='interface') then
    begin
      interfaces(getb);
    end
    else if (s='field') then
    begin
      fields(flags(getb),gets,getb);
    end
    else if (s='method') then
    begin
      method(flags(getb),gets,getb);
    end
    else if (s='endmethod') then
    begin
      {end curent method{}
    end
    else if (s='attribute') then
    begin

    end
    else if (s='endattribute') then
    begin

    end
    else if (s='localvariabletable') then
    begin

    end
    else
    begin
      {code parse...}
    end;
  end;
  freeMem(cf.attribute_info,  $7FFF);
  freeMem(cf.method_info,     $FFFF);
  freeMem(cf.field_info,      $7FFF);
  freeMem(cf.interfaces,      $7FFF);
  freeMem(cf.cp_info,         $FFFF);
  close(f);
end.
